From: Jan Kiszka <jan.kiszka@siemens.com>
To: Alexander Smirnov <asmirnov@ilbers.de>, isar-users@googlegroups.com
Subject: Re: [PATCH v3 4/4] dpkg-base: Update git alternates
Date: Mon, 11 Dec 2017 19:03:54 +0100 [thread overview]
Message-ID: <181d9342-4366-cdbb-e86b-99ee62d95dcd@siemens.com> (raw)
In-Reply-To: <20171126220025.14168-5-asmirnov@ilbers.de>
On 2017-11-26 23:00, Alexander Smirnov wrote:
> Update git alternates to work in buildchroot.
>
> Signed-off-by: Alexander Smirnov <asmirnov@ilbers.de>
> ---
> meta/classes/dpkg-base.bbclass | 12 ++++++++++++
> 1 file changed, 12 insertions(+)
>
> diff --git a/meta/classes/dpkg-base.bbclass b/meta/classes/dpkg-base.bbclass
> index 5d7f8b6..6a78a26 100644
> --- a/meta/classes/dpkg-base.bbclass
> +++ b/meta/classes/dpkg-base.bbclass
> @@ -18,12 +18,24 @@ dpkg_runbuild() {
>
> # Wrap the function dpkg_runbuild with the bind mount for buildroot
> do_build() {
> + if [ -d ${WORKDIR}/git/.git ]; then
> + OBJ_PATH=$(cat ${WORKDIR}/git/.git/objects/info/alternates)
> + REPO_PATH=$(dirname $OBJ_PATH)
> + REPO_NAME=$(basename $REPO_PATH)
> + echo "/git/$REPO_NAME/objects" > ${WORKDIR}/git/.git/objects/info/alternates
> + fi
> +
> mkdir -p ${BUILDROOT}
> sudo mount --bind ${WORKDIR} ${BUILDROOT}
> _do_build_cleanup() {
> ret=$?
> sudo umount ${BUILDROOT} 2>/dev/null || true
> sudo rmdir ${BUILDROOT} 2>/dev/null || true
> +
> + if [ -d ${WORKDIR}/git/.git ]; then
> + echo $OBJ_PATH > ${WORKDIR}/git/.git/objects/info/alternates
> + fi
> +
> (exit $ret) || sudo umount ${BUILDCHROOT_DIR}/git
> (exit $ret) || bb_exit_handler
> }
>
You can probably also amend (>>) the existing alternates with the path
that is active in the chroot so that you can also look at the repo
outside of it.
Jan
--
Siemens AG, Corporate Technology, CT RDA ITP SES-DE
Corporate Competence Center Embedded Linux
next prev parent reply other threads:[~2017-12-11 18:03 UTC|newest]
Thread overview: 11+ messages / expand[flat|nested] mbox.gz Atom feed top
2017-11-26 22:00 [PATCH v3 0/4] Buildchroot prepare/cleanup Alexander Smirnov
2017-11-26 22:00 ` [PATCH v3 1/4] dpkg-base: Fix buildchroot dependency Alexander Smirnov
2017-11-26 22:00 ` [PATCH v3 2/4] image: Add do_rootfs template to image class Alexander Smirnov
2017-11-26 22:00 ` [PATCH v3 3/4] buildchroot: Add prepare and cleanup tasks Alexander Smirnov
2017-11-26 22:00 ` [PATCH v3 4/4] dpkg-base: Update git alternates Alexander Smirnov
2017-12-11 17:56 ` Henning Schild
2017-12-11 19:45 ` Alexander Smirnov
2017-12-12 11:49 ` Henning Schild
2017-12-12 12:30 ` Alexander Smirnov
2017-12-11 18:03 ` Jan Kiszka [this message]
2017-12-11 19:49 ` Alexander Smirnov
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=181d9342-4366-cdbb-e86b-99ee62d95dcd@siemens.com \
--to=jan.kiszka@siemens.com \
--cc=asmirnov@ilbers.de \
--cc=isar-users@googlegroups.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox